QT += quick qml quickcontrols2 purchasing widgets
CONFIG += c++11

VERSION = 0.04

android {
    QT += androidextras
    android: include(/home/dorian/Android/Sdk/android_openssl/openssl.pri)
    ANDROID_PACKAGE_SOURCE_DIR = $$PWD/android-sources
}

ios {
    QMAKE_ASSET_CATALOGS += resources/shared/Assets.xcassets
    xcode_product_bundle_identifier_setting.value = "de.itsblue.bluerock"
}

# The following define makes your compiler emit warnings if you use
# any Qt feature that has been marked deprecated (the exact warnings
# depend on your compiler). Refer to the documentation for the
# deprecated API to know how to port your code away from it.
DEFINES += QT_DEPRECATED_WARNINGS

# You can also make your code fail to compile if it uses deprecated APIs.
# In order to do so, uncomment the following line.
# You can also select to disable deprecated APIs only up to a certain version of Qt.
#DEFINES += QT_DISABLE_DEPRECATED_BEFORE=0x060000    # disables all the APIs deprecated before Qt 6.0.0

SOURCES += \
    sources/brathlete.cpp \
    sources/brleague.cpp \
    sources/appsettings.cpp \
    sources/brcalendar.cpp \
    sources/competition/brround.cpp \
    sources/brseason.cpp \
    sources/brserverconnector.cpp \
    sources/brwidget.cpp \
    sources/competition/result/brresultdetailsgeneralresult.cpp \
    sources/main.cpp \
    sources/brcontroller.cpp \
    sources/provider/brprovider.cpp \
    sources/provider/brproviderdr.cpp \
    sources/provider/brprovidervl.cpp \
    sources/competition/brcategory.cpp \
    sources/competition/brcompetition.cpp \
    sources/competition/result/brresult.cpp \
    sources/competition/result/brresultdetails.cpp \
    sources/competition/result/brresultdetailsunknown.cpp \
    sources/cup/brcup.cpp


HEADERS += \
    headers/brathlete.h \
    headers/brleague.h \
    headers/appsettings.h \
    headers/brcalendar.h \
    headers/competition/brcategory.h \
    headers/competition/brcompetition.h \
    headers/brcontroller.h \
    headers/brseason.h \
    headers/brserverconnector.h \
    headers/brwidget.h \
    headers/competition/result/brresultdetailsgeneralresult.h \
    headers/provider/brprovider.h \
    headers/provider/brproviderdr.h \
    headers/provider/brprovidervl.h \
    headers/competition/brround.h \
    headers/competition/result/brresult.h \
    headers/competition/result/brresultdetails.h \
    headers/competition/result/brresultdetailsunknown.h \
    headers/cup/brcup.h

INCLUDEPATH += \
    headers \
    headers/provider \
    headers/competition \
    headers/competition/result \
    headers/cup

RESOURCES += resources/qml/qml.qrc \
    resources/shared/shared.qrc \
    #resources/shared/icons/bluerock/index.theme \
    #$$files(resources/shared/icons/*.png, true)


# Additional import path used to resolve QML modules in Qt Creator's code model
QML_IMPORT_PATH =

# Additional import path used to resolve QML modules just for Qt Quick Designer
QML_DESIGNER_IMPORT_PATH =

# Default rules for deployment.
qnx: target.path = /tmp/$${TARGET}/bin
else: unix:!android: target.path = /opt/$${TARGET}/bin
!isEmpty(target.path): INSTALLS += target

DISTFILES += \
    CHANGELOG.md \
    android-sources/AndroidManifest.xml \
    android-sources/build.gradle \
    android-sources/gradle/wrapper/gradle-wrapper.jar \
    android-sources/gradle/wrapper/gradle-wrapper.properties \
    android-sources/gradlew \
    android-sources/gradlew.bat \
    android-sources/res/values/libs.xml \
    resources/shared/icons/bluerock/index.theme \
    $$files(resources/shared/icons/*.png, true)

ANDROID_ABIS = armeabi-v7a

contains(ANDROID_TARGET_ARCH,armeabi-v7a) {
    ANDROID_ABIS = \
        armeabi-v7a
}
