#ifndef BRRESULTDATA_H
#define BRRESULTDATA_H

#include <QObject>

#include "brwidget.h"

class BRResult;

class BRResultDetails : public BRWidget
{
    Q_OBJECT
    Q_PROPERTY(BRResultDetailsType type READ getType NOTIFY metadataChanged)
public:
    friend class BRResult;

    enum BRResultDetailsType {
        UnknownResultType = -1,
        GeneralResult,
        SpeedQualificationResult,
        SpeedFinalResult,
        LeadResult,
        BoulderResult,
        CombinedResult
    };

    BRWidget::BRWidgetStatusCode load() final override;
    Q_INVOKABLE virtual QString toString() = 0;

    Q_INVOKABLE virtual QString string() final;

    Q_INVOKABLE BRResultDetailsType getType();

protected:
    BRResultDetails(BRResultDetailsType type);

    BRResult* getResult();

private:

    BRResult* result;
    BRResultDetailsType type;


    BRWidget::BRDiscipline getDiscipline();
signals:
    void metadataChanged();
};

#endif // BRRESULTDATA_H
