#ifndef BRPROVIDERDR_H
#define BRPROVIDERDR_H

#include <QObject>

#include "brprovider.h"

class BRProviderDr : public BRProvider
{
    Q_OBJECT
public:
    explicit BRProviderDr(QObject *parent = nullptr);

protected:
    BRWidget::BRWidgetStatusCode getWidgetData(BRCalendar::BRCalendarData*  calendarData) override;

    BRWidget::BRWidgetStatusCode getWidgetData(BRSeason::BRSeasonData*  seasonData) override;
    BRSeason::BRSeasonData parseSeasonData(int id, QVariantMap rawData);
    void parseSeasonData(BRSeason::BRSeasonData* seasonData, int id, QVariantMap rawData);

    BRWidget::BRWidgetStatusCode getWidgetData(BRLeague::BRLeagueData*  leagueData) override;
    BRLeague::BRLeagueData parseLeagueData(QVariantMap leagueProperties, QVariantMap rawData);

    BRWidget::BRWidgetStatusCode getWidgetData(BRCompetition::BRCompetitionData* competitionData) override;
    BRCompetition::BRCompetitionData parseCompetitionData(QVariantMap rawData, QVariantList globalCategoriesList, BRWidget::BRFederation federation);
    void parseCompetitionData(BRCompetition::BRCompetitionData* competitionData, QVariantMap rawData, BRWidget::BRFederation federation);

    BRCup::BRCupData parseCupData(QVariantList categoriesList, QVariantMap rawData, BRWidget::BRFederation federation);

    BRCategory::BRCategoryData parseCategoryData(QVariantMap rawData);
    void parseCategoryData(BRCategory::BRCategoryData* categoryData, QVariantMap rawData);

    void parseRoundData(BRRound::BRRoundData* roundData, QVariantMap rawData, QString resultKeyAttachment = "");

    BRAthlete::BRAthleteData parseAthletedata(QVariantMap rawData);

    BRResult::BRResultData parseResultData(QVariantMap rawData);

private:
    QMap<BRWidget::BRFederation, QList<QVariantMap>> leagues;

};

#endif // BRPROVIDERDR_H
