#ifndef BRPROVIDERVL_H
#define BRPROVIDERVL_H

#include <QObject>

#include "brprovider.h"

class BRProviderVl : public BRProvider
{
    Q_OBJECT
public:
    explicit BRProviderVl(QObject *parent = nullptr);

protected:
    BRWidget::BRWidgetStatusCode getWidgetData(BRCalendar::BRCalendarData*  calendarData) override;

    BRWidget::BRWidgetStatusCode getWidgetData(BRSeason::BRSeasonData*  seasonData) override;
    BRSeason::BRSeasonData parseSeasonData(QVariantMap rawData);

    BRWidget::BRWidgetStatusCode getWidgetData(BRLeague::BRLeagueData*  leagueData) override;
    void parseLeagueData(BRLeague::BRLeagueData* leagueData, QVariantMap rawData);

    BRWidget::BRWidgetStatusCode getWidgetData(BRCompetition::BRCompetitionData* competitionData) override;
    BRCompetition::BRCompetitionData parseCompetitionData(QVariantMap rawData, QVariantList globalCategoriesList, BRWidget::BRFederation federation);

    BRCup::BRCupData parseCupData(QVariantMap rawData, QVariantList globalCategoriesList);

    BRCategory::BRCategoryData parseCategoryData(QVariantMap rawData);
    //void parseCategoryData(BRCategory::BRCategoryData* categoryData, QVariantMap rawData);

    BRRound::BRRoundData parseRoundData(QVariantMap rawData);
    void parseRoundData(BRRound::BRRoundData* roundData, QVariantMap rawData);

private:
    QMap<BRWidget::BRFederation, QList<QVariantMap>> leagues;

};

#endif // BRPROVIDERVL_H
