/*
    blueROCK - for digital rock
    Copyright (C) 2019  Dorian Zedler

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

import QtQuick 2.10
import QtQuick.Controls 2.4
import QtQuick.Layouts 1.3
import QtQuick.Controls.Material 2.1

ListView {
    id: control

    property var flowchartData
    property var allFlowchartData
    property int rounds: 0
    property int tileSize: app.height / 8 * 0.8

    property int refreshes: 0
    property int roundRefreshes: 1

    anchors.fill: parent
    anchors.margins: 10

    spacing: app.width * 0.1

    orientation: ListView.LeftToRight
    boundsBehavior: ListView.StopAtBounds

    onFlowchartDataChanged: {
        prepareData()
    }

    model: 0

    function prepareData() {

        if(!control.enabled || control.flowchartData === undefined || control.flowchartData['route_names'] === undefined)
            return
        /*refreshes += 1

        if(refreshes > 2){
            roundRefreshes += 1
        }

        console.log("refreshes: " + refreshes + " rounds: " + roundRefreshes)

        // create competition like data (just testing)
        for(var part in flowchartData['participants']){
            if(flowchartData['participants'].hasOwnProperty(part)){

                for(var r = 2 + roundRefreshes; r < 7; r++){
                    delete flowchartData['participants'][part]["result"+r]
                    delete flowchartData['participants'][part]["result_rank"+r]
                }

                if(parseInt(flowchartData['participants'][part]["result_rank0"]) > 14 + refreshes) {
                    delete flowchartData['participants'][part]["result_rank2"]
                }
            }
        }


        delete flowchartData['route_names'][2]
        delete flowchartData['route_names'][3]
        delete flowchartData['route_names'][4]
        delete flowchartData['route_names'][5]
        delete flowchartData['route_names'][6]
        */

        //flowchartData['route_names'] = flowchartData['route_names'].slice(0,)

        // array to store the restructured data
        var allData = []
        control.allFlowchartData = []

        control.rounds = Object.keys(control.flowchartData['route_names']).length > 2 ? control.flowchartData['route_names']["2"].includes("8") ? 2:1 : 0

        //console.log(JSON.stringify(flowchartData['route_names']))

        for(var round in flowchartData['route_names']){
            if(flowchartData['route_names'].hasOwnProperty(round) && parseInt(round) >= 0){
                //console.log(round)

                if(parseInt(round) === 0){
                    // this is the first round

                    // find pairs (always wors vs. best (1-16; 1-15; ...)) (they are sorted by the rank of the better athlete (1-2-3-4-5-6-7-8)

                    var qualificationResults = []

                    for(var x = 0; x < flowchartData['participants'].length; x++){
                        qualificationResults.push(flowchartData['participants'][x])
                    }

                    qualificationResults.sort(function(a, b) {
                        return parseInt(a["result_rank0"]) - parseInt(b["result_rank0"]);
                    });

                    var nextRoundPairs = []
                    var totalMatches = (parseInt(Object.keys(control.flowchartData['route_names']).length > 2 ? control.flowchartData['route_names']["2"].includes("8") ? 2:1 : 0) + 2)
                    var nextRoundMatches = Math.pow(2, totalMatches-1)

                    for(var i = 0; i < nextRoundMatches; i++){
                        nextRoundPairs.push([qualificationResults[i], qualificationResults[nextRoundMatches*2-i-1]])
                    }

                    // build second round pairs (sorted by the rank of the better athlete and worst vs. best (1-8; 2-7; ... ))

                    var sortedFirstRoundPairs = []

                    for(i = 0; i < nextRoundMatches; i += 1){
                        sortedFirstRoundPairs.push([nextRoundPairs.shift(), nextRoundPairs.pop()])
                    }

                    // sort these pairs (containing two pairs of athletes) by the rank of the better athlete (1-4;2-3)

                    var finalSortedFirstRoundPairs = []

                    for(i=0; i < nextRoundMatches/4; i++){
                        finalSortedFirstRoundPairs.push(sortedFirstRoundPairs[i])
                        finalSortedFirstRoundPairs.push(sortedFirstRoundPairs[nextRoundMatches/2-i-1])
                    }

                    // convert the list of pairs of pairs of athletes back to a single list of pairs of athletes

                    var finalFirstRoundPairs = []

                    for(i=0; i < finalSortedFirstRoundPairs.length; i++){
                        finalFirstRoundPairs.push(finalSortedFirstRoundPairs[i][0])
                        finalFirstRoundPairs.push(finalSortedFirstRoundPairs[i][1])
                    }

                    // push the first round to all data
                    finalFirstRoundPairs.push(2)
                    finalFirstRoundPairs.push(flowchartData['route_names'][2])
                    allData.push(finalFirstRoundPairs)

                }
                else if(parseInt(round) > 0 ){
                    // this is not the first round

                    var nextRound = []

                    // only used when  the current round is the 1/2 final
                    var smallFinal = []
                    var Final = []

                    for(var i = 0; i < allData[allData.length-1].length-2; i+=1){

                        var thisPair = allData[allData.length-1][i]
                        var thisWinner
                        var thisLooser
                        var thisWinnerIsFirstOfNewPair = i%2 === 0

                        if(thisPair[0] === undefined || thisPair[1] === undefined){
                            continue
                        }

                        if(thisWinnerIsFirstOfNewPair){
                            nextRound.push([])
                        }

                        //thisPair[0]["result_rank"] = thisPair[0]["result_rank"+round]
                        //thisPair[1]["result_rank"] = thisPair[1]["result_rank"+round]

                        if(parseInt(thisPair[0]["result_rank"+round]) < parseInt(thisPair[1]["result_rank"+round])){
                            thisWinner = thisPair[0]
                            thisLooser = thisPair[1]
                        }
                        else if(parseInt(thisPair[0]["result_rank"+round]) > parseInt(thisPair[1]["result_rank"+round])) {
                            thisWinner = thisPair[1]
                            thisLooser = thisPair[0]
                        }
                        else {
                            // no result yet!!
                            //console.log("got no winner yet, rank 0: " + thisPair[0]["result_rank"+round] + " rank 1: " + thisPair[1]["result_rank"+round])
                            continue
                        }

                        //console.log(thisWinner['firstname']+" has won in round " + round)

                        if(round - control.rounds === 2){
                            // if we are in the 1/2 final

                            Final.push(thisWinner)
                            smallFinal.push(thisLooser)
                        }
                        else {
                            nextRound[nextRound.length-1].push(thisWinner)
                        }
                    }

                    if(smallFinal.length > 0 && Final.length > 0){

                        // Final
                        allData.push([Final, parseInt(round)+2, flowchartData['route_names'][String(parseInt(round)+2)] + " / " + flowchartData['route_names'][String(parseInt(round)+1)] ])
                        // small Final
                        allData.push([smallFinal, parseInt(round)+1])

                        //break
                    }
                    else {
                        nextRound.push(parseInt(round) + 1 )
                        nextRound.push(flowchartData['route_names'][parseInt(round) + 1])
                        allData.push(nextRound)
                    }
                }
            }
        }

        control.allFlowchartData = allData
        control.model = (parseInt(Object.keys(control.flowchartData['route_names']).length > 2 ? control.flowchartData['route_names']["2"].includes("8") ? 2:1 : 0) + 2)
        //console.log(JSON.stringify(allData))
    }

    delegate: Column {
        id: roundCol

        property int thisIndex: index
        property int thisRound: thisRoundIsValid ? control.allFlowchartData[roundCol.thisIndex][control.allFlowchartData[roundCol.thisIndex].length-2]:-1
        property bool thisRoundIsValid: control.allFlowchartData !== undefined && control.allFlowchartData[roundCol.thisIndex] !== undefined && control.allFlowchartData[roundCol.thisIndex].length > 2
        property bool thisIsLastRound: thisIndex === control.model - 1

        width: app.width * 0.5
        height: control.height

        //spacing: app.width * 0.1

        Label {
            id: roundNameLa
            width: parent.width
            height: control.height * 0.05
            horizontalAlignment: Text.AlignHCenter
            verticalAlignment: Text.AlignVCenter
            fontSizeMode: Text.Fit
            font.pixelSize: height * 0.6
            minimumPixelSize: 1
            font.bold: true
            text: roundCol.thisRoundIsValid && control.allFlowchartData[roundCol.thisIndex][control.allFlowchartData[roundCol.thisIndex].length-1] !== undefined ? control.allFlowchartData[roundCol.thisIndex][control.allFlowchartData[roundCol.thisIndex].length-1] : "-"
        }

        Repeater {
            id: rectRep
            model: Math.max( Math.pow(2, control.model-1) * Math.pow(0.5, (index)), 2)
            delegate: Item {
                id: matchItm

                property bool lowerPart: (index%2 > 0)

                property var matchData: roundCol.thisRoundIsValid ? control.allFlowchartData[ thisIsSmallFinal ? roundCol.thisIndex+1 : roundCol.thisIndex][ thisIsSmallFinal ? 0:matchItm.thisIndex]:undefined

                property int thisIndex: index
                property int thisRound: parseInt(roundCol.thisRound) - (thisIsSmallFinal ? 1:0)
                property var thisMatchData: thisMatchDataIsValid ? matchData:[]

                property bool thisMatchDataIsValid: (matchData !== undefined && matchData !== null && typeof matchData === "object" && matchData.length > 0)
                property bool thisMatchIsOver: thisMatchDataIsValid && thisMatchData[0]['result_rank'+thisRound] !== undefined && thisMatchData[1]['result_rank'+thisRound] !== undefined

                property bool thisIsFinal: roundCol.thisIsLastRound && thisIndex === rectRep.model - 2
                property bool thisIsSmallFinal: roundCol.thisIsLastRound && thisIndex === rectRep.model - 1

                property int winnerIndex: thisMatchIsOver ? (parseInt(thisMatchData[0]['result_rank'+thisRound]) < parseInt(thisMatchData[1]['result_rank'+thisRound]) ? 0:1) : -1

                height: !roundCol.thisIsLastRound ? (roundCol.height - roundNameLa.height) / rectRep.model - roundCol.spacing : (thisIsFinal ? (roundCol.height - roundNameLa.height) * 0.5 + control.tileSize * 0.5 :  (roundCol.height - roundNameLa.height) - (roundCol.height - roundNameLa.height) * 0.5 + control.tileSize * 0.5 )
                width: parent.width

                onMatchDataChanged: {
                    fadeInPa.start()
                }

                ParallelAnimation {
                    id: fadeInPa
                    NumberAnimation { target: matchItm; property: "opacity"; from: 0; to: 1.0; duration: 400 }
                    NumberAnimation { target: matchItm; property: "scale"; from: 0.8; to: 1.0; duration: 400 }
                }

                Canvas {
                    id: lineCanvas
                    width: app.width; height: app.height
                    contextType: "2d"

                    visible: !roundCol.thisIsLastRound

                    property int targetX: matchItm.width + control.spacing
                    property int targetY: matchItm.lowerPart ? 0:matchItm.height

                    Path {
                        id: myPath
                        startX: matchRect.x + matchRect.width * matchRect.scale ; startY: matchRect.y + matchRect.height * 0.5

                        PathCurve { x: lineCanvas.targetX ; y: lineCanvas.targetY }
                    }

                    onPaint: {
                        context.strokeStyle = Qt.rgba(.4,.6,.8);
                        context.path = myPath;
                        context.stroke();
                    }
                }

                Rectangle {
                    id: matchRect

                    anchors {
                        centerIn: !matchItm.thisIsFinal ? parent:undefined
                        bottom: matchItm.thisIsFinal ? parent.bottom:undefined
                    }

                    //anchors.verticalCenterOffset: matchItm.lowerPart ? 10:10
                    width: parent.width
                    height: control.tileSize
                    //scale: 0.9
                    color: "white"
                    border.color: "lightgrey"
                    border.width: 1
                    radius: height * 0.2
                    Material.elevation: 10

                    Grid {
                        columns: app.landscape() ? 2:0
                        rows: app.landscape() ? 0:2

                        spacing: app.landscape() ? height * 0.4:0

                        anchors.fill: parent
                        anchors.margins: matchRect.radius * 0.5

                        Repeater {
                            // for the two athletes
                            model: 2

                            delegate: RowLayout {

                                height: app.landscape() ? parent.height:parent.height / 2 - parent.spacing
                                width: app.landscape() ? parent.width / 2 - parent.spacing : parent.width

                                spacing: app.landscape() ? height * 0.1:height * 0.1

                                Label {
                                    Layout.preferredHeight: parent.height

                                    height: parent.height

                                    verticalAlignment: Text.AlignVCenter
                                    font.pixelSize: height * 0.7
                                    fontSizeMode: Text.Fit
                                    minimumPixelSize: 1

                                    Layout.alignment: Layout.Left

                                    text: matchItm.thisMatchData[index] !== undefined ? (parseInt(matchItm.thisMatchData[index]['result_rank0'])  < 10 ?matchItm.thisMatchData[index]['result_rank0'] + " ":matchItm.thisMatchData[index]['result_rank0']): ""
                                }

                                Label {
                                    Layout.preferredHeight: parent.height

                                    height: parent.height

                                    verticalAlignment: Text.AlignVCenter
                                    horizontalAlignment: Text.AlignHCenter
                                    //horizontalAlignment: app.landscape() ? Text.AlignLeft : Text.AlignLeft
                                    font.pixelSize: app.landscape() ? height * 0.4 : height * 0.6
                                    minimumPixelSize: (app.landscape() ? height * 0.35 : height * 0.5) < 1 ? 1 : (app.landscape() ? height * 0.35 : height * 0.5)
                                    fontSizeMode: Text.Fit
                                    font.bold: matchItm.winnerIndex === index
                                    elide: "ElideRight"

                                    Layout.fillWidth: true

                                    color: matchItm.winnerIndex === index ? "green":"black"

                                    text: matchItm.thisMatchData[index] !== undefined ? matchItm.thisMatchData[index]['firstname'] + " " + matchItm.thisMatchData[index]['lastname'] :"-"
                                }

                                Label {
                                    Layout.preferredHeight: parent.height

                                    height: parent.height

                                    verticalAlignment: Text.AlignVCenter
                                    font.pixelSize: app.landscape() ? height * 0.35 : height * 0.5

                                    Layout.alignment: Layout.Right

                                    text: matchItm.thisMatchData[index] !== undefined && matchItm.thisMatchData[index]['result'+matchItm.thisRound] !== undefined ?
                                                ( parseFloat(matchItm.thisMatchData[index]['result'+matchItm.thisRound]) ?
                                                    (parseFloat(matchItm.thisMatchData[index]['result'+matchItm.thisRound]).toFixed(2))
                                                    : matchItm.thisMatchData[index]['result'+matchItm.thisRound] )
                                                : "-"
                                }
                            }
                        }
                    }
                }
            }
        }
    }
}

