/*
    blueROCK - for digital rock
    Copyright (C) 2019  Dorian Zedler

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

import QtQuick 2.0
import QtQuick.Controls 2.4
import de.itsblue.blueRock 2.0

import "../Components"

Page {
    id: root

    title: "start"
    property Component headerComponent: null

    Label {
        anchors {
            horizontalCenter: parent.horizontalCenter
            top: parent.top
            topMargin: root.height * 0.03
        }

        font.pixelSize: anchors.topMargin
        font.bold: true

        text: "blueROCK"
    }

    Grid {
        id: menuGr

        anchors.centerIn: parent

        rows: app.landscape() ? 1:3
        columns:  app.landscape() ? 3:1

        spacing: !app.landscape() ? parent.height * 0.08:parent.width * 0.1

        property int buttonSize: app.landscape() ? parent.width * 0.2:parent.height * 0.2

        FancyButton {
            id: ifscBt

            height: menuGr.buttonSize
            width: height

            image: "qrc:/icons/ifsc.png"

            onClicked: app.openCalendar(BRWidget.IFSC)
        }

        FancyButton {
            id: davBt

            height: menuGr.buttonSize
            width: height

            image: "qrc:/icons/dav.png"

            onClicked: app.openCalendar(BRWidget.DAV)
        }

        FancyButton {
            id: sacBt

            height: menuGr.buttonSize
            width: height

            image: "qrc:/icons/sac.png"

            onClicked: app.openCalendar(BRWidget.SAC)
        }

    }

    Label {
        anchors {
            horizontalCenter: parent.horizontalCenter
            bottom: parent.bottom
            bottomMargin: root.height * 0.03
        }

        width: parent.width * 0.9
        height: anchors.bottomMargin

        wrapMode: "Wrap"
        horizontalAlignment: Text.AlignHCenter

        text: "Resultservice and rankings provided by <a href='http://www.digitalROCK.de'>digital ROCK</a>."

        onLinkActivated: {
            Qt.openUrlExternally(link)
        }
    }

}
