#include "brwidget.h"

#include "brprovider.h"

BRWidget::BRWidget(BRProvider* provider, BRFederation federation, int id) : QObject(provider), provider(provider), federation(federation), id(id)
{
    this->state = Unconfigured;
}


BRWidget::BRWidgetState BRWidget::getState() const {
    return this->state;
}

void BRWidget::setState(BRWidgetState state) {
    if(this->state == state)
        return;

    this->state = state;
    emit this->stateChanged();
}

BRWidget::BRFederation BRWidget::getFederation() const {
    return this->federation;
}

BRProvider* BRWidget::getProvider() {
    return this->provider;
}

int BRWidget::getId() const {
    return this->id;
}
